package com.dsic.gj_erp.pc;

import cn.hutool.core.date.DateTime;
import cn.hutool.core.date.DateUtil;
import cn.hutool.core.util.ObjUtil;
import cn.hutool.core.util.StrUtil;
import com.alibaba.fastjson.JSONObject;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import com.dsic.gj_erp.bean.SpringContextHolder;
import com.dsic.gj_erp.bean.jcsj.DmBom;
import com.dsic.gj_erp.bean.jcsj.EmGcrl;
import com.dsic.gj_erp.bean.jcsj.EmSbcnp;
import com.dsic.gj_erp.bean.jcsj.EmSbjbb;
import com.dsic.gj_erp.bean.jhgk.DmSygdxq;
import com.dsic.gj_erp.pc.dto.gx.*;
import com.dsic.gj_erp.pc.dto.sb.*;
import com.dsic.gj_erp.pc.dto.工序产能;
import com.dsic.gj_erp.pc.dto.排产结果;
import com.dsic.gj_erp.pc.dto.设备;
import com.dsic.gj_erp.pc.dto.资源;
import com.dsic.gj_erp.service.jcsj.EmGcrlService;
import com.dsic.gj_erp.service.jcsj.EmSbcnpService;
import com.dsic.gj_erp.service.jcsj.EmSbjbbService;
import com.dsic.gj_erp.service.jhgk.DmSygdxqService;
import com.google.common.collect.ImmutableMap;

import java.io.FileOutputStream;
import java.io.OutputStream;
import java.util.*;
import java.util.stream.Collectors;

import static com.dsic.gj_erp.pc.Constant.工序CD;
import static com.dsic.gj_erp.pc.Manager.排产;
import static com.dsic.gj_erp.pc.Manager.*;

public class DataFactory {

    public static void 排产(){
        套料图所占工序的资源.clear();
        List<排产结果> list = 排产.list;
        List<DmBom> 强占记录=new ArrayList<>();
        list.clear();
        List<DmSygdxq> 按需求日期排序的钢料需求 = getBean(DmSygdxqService.class).getXqWithBom(from, to);
        按需求日期排序的钢料需求.forEach(钢料需求->{
            钢料需求.getBomList().forEach(bom->{
                Arrays.stream(Constant.工序.values()).forEach(gx->{
                    if (StrUtil.isEmpty(gx.getCode()))return;
                    //todo 由于工序code存在多个值的情况,这里需要抽象套料图工序,修改后可支持多线程运算
                    if (ObjUtil.isNotEmpty(套料图工序对应关系.get(bom.getKw()+bom.getZl()+"_"+gx.getCode()))){
                        Integer cd = 工序CD.get(gx);
                        DateTime parse = DateUtil.parse(钢料需求.getXzglxq(), "yyyy/MM/dd");
                        DateTime dateTime = DateUtil.offsetDay(parse, cd);
                        资源 _资源 = 提取资源(dateTime);
                        //除切割工序外默认需求数量都是1
                        //todo 如果是切割工序需要获取切割长度
                        double 需求数量=bom.getTlsl().doubleValue();
                        Optional.of(_资源).ifPresent(it->{
                            工序产能 工序产能=null;
                            资源 资源 = 套料图所占工序的资源.get(bom.getTzbh());
                            if (资源!=null){
                                工序产能 = 资源.get工序产能MAP().get(gx);
                            }
                            if (工序产能!=null&&工序产能.get资源占用图纸表().contains(bom.getTzbh())){
                                bom.set所在资源(it);
                                Optional<设备> _设备 = 工序产能.获取已占用设备(bom.getTzbh());
                                _设备.ifPresent(bom::set所在设备);
                            }else{
                                工序产能 = it.get工序产能MAP().get(gx);
                                Optional<设备> _设备 = 工序产能.获取可占用设备(需求数量);
                                工序产能 final工序产能 = 工序产能;
                                _设备.ifPresent(tmp->{
                                    bom.set所在设备(tmp);
                                    tmp.占用设备(bom.getTzbh(),需求数量);
                                    bom.set所在资源(it);
                                    final工序产能.占用资源(bom.getTzbh(), 需求数量);
                                    套料图所占工序的资源.put(bom.getTzbh(),it);
                                });
                            }
                        });

                        //没有可用资源是全局搜索可用资源,进行排产
                        if (bom.get所在设备()==null){
                            Optional<资源> 可用资源 = 搜索可用资源(gx, DateUtil.parse(from,"yyyy/MM/dd"), parse,需求数量);
                            可用资源.ifPresent(tmp资源->{
                                工序产能 _工序产能 = tmp资源.get工序产能MAP().get(gx);
                                Optional<设备> _设备 = _工序产能.获取可占用设备(0);
                                _设备.ifPresent(tmp->{
                                    tmp.占用设备(bom.getTzbh(),需求数量);
                                    bom.set所在设备(tmp);
                                    _工序产能.占用资源(bom.getTzbh(), 需求数量);
                                    bom.set所在资源(tmp资源);
                                    套料图所占工序的资源.put(bom.getTzbh(),tmp资源);
                                });
                            });
                        }

                        //没有可用资源放入月末(强占),待手工调整
                        if (bom.get所在设备()==null){
                            强占记录.add(bom);
                            资源 tmp资源 = 提取资源(DateUtil.endOfMonth(DateUtil.parse(钢料需求.getXzglxq(), "yyyy/MM/dd")));
                            工序产能 _工序产能 = tmp资源.get工序产能MAP().get(gx);
                            Optional<设备> _设备 = _工序产能.get设备().values().stream().findAny();
                            bom.set所在设备(_设备.get());
                            bom.set所在资源(tmp资源);
                            _工序产能.占用资源(bom.getTzbh(),0);
                            套料图所占工序的资源.put(bom.getTzbh(),tmp资源);
                        }
                    }
                });
            });
        });
        //========调试打印===========
        资源池.forEach((day,item)->{
            System.out.println("====打印资源===");
            System.out.println(day);
            Map<Constant.工序, 工序产能> 工序产能MAP = item.get工序产能MAP();
            工序产能MAP.forEach((工序,工序产能)->{
                if (工序产能.get资源占用图纸表().size()>0){
                    System.out.println("工序:"+工序);
                    if ("2024/06/03".equals(day)){
                        System.out.println(工序产能.get资源占用图纸表());
                    }
                    System.out.println("工序产能:"+工序产能.get资源占用图纸表().size());
                }
            });
            System.out.println("====打印资源完成===");
        });
        System.out.println(强占记录.size());
        //========调试打印结束===========
    }

    public static Optional<资源> 搜索可用资源(Constant.工序 工序,Date 搜索起始日期,Date 搜索截止日期, double 需求数量){
        return 资源池.values().stream().filter(资源->{
            工序产能 工序产能 = 资源.get工序产能MAP().get(工序);
            Date 资源日期=DateUtil.parse(资源.getDate(),"yyyy/MM/dd");
            return 工序产能.判断是否可以占用(需求数量)&&资源日期.after(搜索起始日期)&&资源日期.before(搜索截止日期);
        }).findFirst();
    }

    public static 资源 提取资源(Date date){
        资源 资源 = 资源池.get(DateUtil.format(date, "yyyy/MM/dd"));
        if (资源==null){
            return 提取资源(DateUtil.offsetDay(date,-1));
        }
        return 资源;
    }

    public static void 创建产能资源池(){
        资源池.clear();
        工厂日历.stream().filter(item -> "1".equals(item.getXxr()))
                    .forEach(item -> {
                        Map<Constant.工序, 工序产能> map=new HashMap<>();
                        Arrays.stream(Constant.工序.values()).forEach(_item->{
                            if (StrUtil.isNotEmpty(_item.getCode())){
                                map.put(_item,工序产能工厂(_item));
                            }
                        });
                        资源池.put(item.getGl(),资源.of(item.getGl(), map));
                    });
    }

    public static 工序产能 工序产能工厂(Constant.工序 _工序){
        Map<String,设备> _设备=null;
        switch (_工序){
            case 上料:
                _设备= ImmutableMap.<String, 设备>builder()
                        .put(Constant.设备产能.上料01.设备编号,new 设备01上料(Constant.设备产能.上料01))
                        .build();
                return new 工序01上料(_设备);
            case 抛丸:
                _设备=ImmutableMap.<String, 设备>builder()
                        .put(Constant.设备产能.抛丸01.设备编号,new 设备02抛丸(Constant.设备产能.抛丸01))
                        .build();
                return new 工序02抛丸(_设备);
            case 理料:
                _设备=ImmutableMap.<String, 设备>builder()
                        .put(Constant.设备产能.理料01.设备编号,new 设备03理料(Constant.设备产能.理料01))
                        .build();
                return new 工序03理料(_设备);
            case 划线:
                _设备=ImmutableMap.<String, 设备>builder()
                        .put(Constant.设备产能.划线01.设备编号,new 设备04划线(Constant.设备产能.划线01))
                        .build();
                return new 工序04划线(_设备);
            case 切割:
                _设备=ImmutableMap.<String, 设备>builder()
                        .put(Constant.设备产能.龙门01.设备编号,new 设备05切割(Constant.设备产能.龙门01))
                        .put(Constant.设备产能.火焰01.设备编号,new 设备05切割(Constant.设备产能.火焰01))
                        .put(Constant.设备产能.数控01.设备编号,new 设备05切割(Constant.设备产能.数控01))
                        .put(Constant.设备产能.火焰03.设备编号,new 设备05切割(Constant.设备产能.火焰03))
                        .put(Constant.设备产能.数控03.设备编号,new 设备05切割(Constant.设备产能.数控03))
                        .put(Constant.设备产能.龙门03.设备编号,new 设备05切割(Constant.设备产能.龙门03))
                        .put(Constant.设备产能.火焰02.设备编号,new 设备05切割(Constant.设备产能.火焰02))
                        .put(Constant.设备产能.数控02.设备编号,new 设备05切割(Constant.设备产能.数控02))
                        .put(Constant.设备产能.龙门02.设备编号,new 设备05切割(Constant.设备产能.龙门02))
                        .build();
                return new 工序05切割(_设备);
            case 坡口:
                _设备=ImmutableMap.<String, 设备>builder()
                        .put(Constant.设备产能.坡口01.设备编号,new 设备07坡口(Constant.设备产能.坡口01))
                        .build();
                return new 工序07坡口(_设备);
            case 型材面板:
                _设备=ImmutableMap.<String, 设备>builder()
                        .put(Constant.设备产能.型材01.设备编号,new 设备10型材(Constant.设备产能.型材01))
                        .build();
                return new 工序10型材(_设备);
            case 曲加工:
                _设备=ImmutableMap.<String, 设备>builder()
                        .put(Constant.设备产能.曲加工01.设备编号,new 设备08曲面(Constant.设备产能.曲加工01))
                        .build();
                return new 工序08曲面(_设备);
            case 打磨:
                _设备=ImmutableMap.<String, 设备>builder()
                        .put(Constant.设备产能.打磨01.设备编号,new 设备09打磨(Constant.设备产能.打磨01))
                        .build();
                return new 工序09打磨(_设备);
//            case 预配盘:
//                return new 工序01上料(_工序,_设备);
//            case 光电结束:
//                return new 工序01上料(_工序,_设备);
//            case 配送:
//                return new 工序01上料(_工序,_设备);
            default:
                return new 工序99未知(Constant.工序.NULL,_设备);
        }
    }

    public static void 加载工厂日历(){
        List<EmGcrl> list = getBean(EmGcrlService.class).getList(new JSONObject());
        工厂日历.clear();
        工厂日历.addAll(list);
    }

    public static void 加载套料图工序对应关系(){
        套料图工序对应关系.clear();
        List<EmSbcnp> list = getBean(EmSbcnpService.class).list();
        Map<String, List<EmSbcnp>> map = list.stream().collect(Collectors.groupingBy(l -> l.getTzbh() + l.getZl()+"_"+l.getGx()));
        map.keySet().forEach(key->{
            String gxCode=key.split("_")[1];
            套料图工序对应关系.put(key,Constant.工序.getGxByCode(gxCode));
        });
    }

    public static void 加载设备信息(){
        List<EmSbjbb> deviceList = getBean(EmSbjbbService.class).list(Wrappers.<EmSbjbb>lambdaQuery().like(EmSbjbb::getScbs, "1"));
        设备列表.clear();
        设备列表.addAll(deviceList);
    }

    public static void 输出排产结果到EXCEL(OutputStream stream){

    }


    public static void 输出排产结果到EXCEL(String fileName){
        try(FileOutputStream fos=new FileOutputStream(fileName)) {
            输出排产结果到EXCEL(fos);
        }catch (Exception e){
            e.printStackTrace();
        }
    }

    private static <T> T getBean(Class<T> clazz) {
        return SpringContextHolder.getBean(clazz);
    }
    private DataFactory(){}
}
